mcast4-pktfld01 6.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207
  1. #!/bin/sh
  2. ################################################################################
  3. ## ##
  4. ## Copyright (c) International Business Machines Corp., 2006 ##
  5. ## ##
  6. ## This program is free software; you can redistribute it and#or modify ##
  7. ## it under the terms of the GNU General Public License as published by ##
  8. ## the Free Software Foundation; either version 2 of the License, or ##
  9. ## (at your option) any later version. ##
  10. ## ##
  11. ## This program is distributed in the hope that it will be useful, but ##
  12. ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
  13. ## or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License ##
  14. ## for more details. ##
  15. ## ##
  16. ## You should have received a copy of the GNU General Public License ##
  17. ## along with this program; if not, write to the Free Software ##
  18. ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA ##
  19. ## ##
  20. ## ##
  21. ################################################################################
  22. #
  23. # File:
  24. # mcast4-pktfld01
  25. #
  26. # Description:
  27. # Verify that the kernel is not crashed when joining a IPv4 multicast group
  28. # a single socket, then receiving a large number of UDP packets at the socket
  29. #
  30. # Setup:
  31. # See testcases/network/stress/README
  32. #
  33. # Author:
  34. # Mitsuru Chinen <mitch@jp.ibm.com>
  35. #
  36. # History:
  37. # May 1 2006 - Created (Mitsuru Chinen)
  38. #
  39. #-----------------------------------------------------------------------
  40. # Uncomment line below for debug output.
  41. #trace_logic=${trace_logic:-"set -x"}
  42. $trace_logic
  43. # The test case ID, the test case count and the total number of test case
  44. TCID=mcast4-pktfld01
  45. TST_TOTAL=1
  46. TST_COUNT=1
  47. export TCID
  48. export TST_COUNT
  49. export TST_TOTAL
  50. # Make sure the value of LTPROOT
  51. LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
  52. export LTPROOT
  53. # Check the environmanet variable
  54. . check_envval || exit $TST_TOTAL
  55. # Dulation of the test [sec]
  56. NS_DURATION=${NS_DURATION:-3600} # 1 hour
  57. # The number of the test link where tests run
  58. LINK_NUM=${LINK_NUM:-0}
  59. # Network portion of the IPv4 address
  60. NETWORK_PART=${IPV4_NETWORK:-"10.0.0"}
  61. # Netmask of the IPv4 network
  62. NETWORK_MASK=24
  63. # Host portion of the IPv4 address
  64. LHOST_HOST_PART=${LHOST_IPV4_HOST:-"2"} # local host
  65. RHOST_HOST_PART=${RHOST_IPV4_HOST:-"1"} # remote host
  66. # Multicast Address
  67. MCAST_ADDR=224.10.0.1
  68. #-----------------------------------------------------------------------
  69. #
  70. # Function: do_cleanup
  71. #
  72. # Description:
  73. # Recover the system configuration
  74. #
  75. #-----------------------------------------------------------------------
  76. do_cleanup()
  77. {
  78. # Make sure to kill the multicast receiver and sender
  79. killall -SIGHUP ns-mcast_receiver >/dev/null 2>&1
  80. $LTP_RSH $RHOST killall -SIGHUP ns-udpsender >/dev/null 2>&1
  81. # Clean up each interface
  82. initialize_if lhost ${LINK_NUM}
  83. initialize_if rhost ${LINK_NUM}
  84. }
  85. #-----------------------------------------------------------------------
  86. #
  87. # Function: do_setup
  88. #
  89. # Description:
  90. # Configure the ssystem for the test
  91. #
  92. #-----------------------------------------------------------------------
  93. do_setup()
  94. {
  95. # Initialize the system configuration
  96. do_cleanup
  97. # Call do_cleanup function before exit
  98. trap do_cleanup 0
  99. # Unset the maximum number of processes
  100. ulimit -u unlimited
  101. # name of interface of the local/remote host
  102. lhost_ifname=`get_ifname lhost $LINK_NUM`
  103. if [ $? -ne 0 ]; then
  104. tst_resm TBROK "Failed to get the interface name at the local host"
  105. exit $TST_TOTAL
  106. fi
  107. rhost_ifname=`get_ifname rhost $LINK_NUM`
  108. if [ $? -ne 0 ]; then
  109. tst_resm TBROK "Failed to get the interface name at the remote host"
  110. exit $TST_TOTAL
  111. fi
  112. # Set IPv4 addresses to the interfaces
  113. set_ipv4addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
  114. if [ $? -ne 0 ]; then
  115. tst_resm TBROK "Failed to add any IP address at the local host"
  116. exit 1
  117. fi
  118. set_ipv4addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
  119. if [ $? -ne 0 ]; then
  120. tst_resm TBROK "Failed to add any IP address at the remote host"
  121. exit 1
  122. fi
  123. # IPv4 address of the local/remote host
  124. lhost_addr="${NETWORK_PART}.${LHOST_HOST_PART}"
  125. rhost_addr="${NETWORK_PART}.${RHOST_HOST_PART}"
  126. # Make sure the connectvity
  127. check_icmpv4_connectivity $lhost_ifname $rhost_addr
  128. if [ $? -ne 0 ]; then
  129. tst_resm TBROK "There is no IPv4 connectivity."
  130. exit 1
  131. fi
  132. # Make sure the sysctl values
  133. sysctl -w net.ipv4.igmp_max_memberships=20 >/dev/null
  134. if [ $? -ne 0 ]; then
  135. tst_resm TBROK "Failed to set the sysctl value regarding multicast"
  136. exit $TST_TOTAL
  137. fi
  138. sysctl -w net.ipv4.igmp_max_msf=10 >/dev/null
  139. sysctl -w net.ipv4.conf.${lhost_ifname}.force_igmp_version=0 >/dev/null
  140. sysctl -w net.ipv4.conf.all.force_igmp_version=0 >/dev/null
  141. }
  142. #-----------------------------------------------------------------------
  143. #
  144. # Main
  145. #
  146. #
  147. # Test description
  148. tst_resm TINFO "Verify that the kernel is not crashed when joining a IPv4 multicast group a single socket, then receiving a large number of UDP packets at the socket in $NS_DURATION [sec]"
  149. do_setup
  150. # Find the available consecutive ports
  151. mcast_port=`find_portbundle udp 1025 1`
  152. if [ $? -ne 0 ]; then
  153. tst_resm TBROK "No port is available."
  154. exit 1
  155. fi
  156. # Run a receiver
  157. ns-mcast_receiver -f 4 -I $lhost_ifname -m $MCAST_ADDR -p $mcast_port -b
  158. if [ $? -ne 0 ]; then
  159. tst_resm TBROK "Failed to start multicast receiver"
  160. exit 1
  161. fi
  162. # Run a sender
  163. ret=`$LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-udpsender -D $MCAST_ADDR -f 4 -p $mcast_port -s 32767 -m -I $rhost_ifname -t $NS_DURATION' ; echo $?'`
  164. if [ $ret -ne 0 ]; then
  165. tst_resm TBROK "Failed to start multicast sender"
  166. exit 1
  167. fi
  168. #-----------------------------------------------------------------------
  169. #
  170. # Clean up
  171. #
  172. tst_resm TPASS "Test is finished successfully."
  173. exit 0